#include <Pixy2CCC.h>
#include <Pixy2UART.h>
#include <Pixy2I2C.h>
#include <PIDLoop.h>
#include <TPixy2.h>
#include <Pixy2Video.h>
#include <Pixy2Line.h>
#include <Pixy2.h>
#include <Pixy2SPI_SS.h>
#include <Servo.h>


Pixy2 pixy;

Servo right_servo;
Servo left_servo;

int right_servo_pin = 5;
int left_servo_pin = 6;


int m_signature = 0;
int x = 0;
int y = 0;
unsigned int width = 0;
unsigned int height = 0;
unsigned int area = 0;
unsigned int newarea = 0;
int Xmin = 70;
int Xmax = 200;
int maxArea = 0;
int minArea = 0;
static int i = 0;


void setup()
{ 
  
  stop();
  pixy.init();

  right_servo.attach(right_servo_pin);
  left_servo.attach(left_servo_pin);
  
  Serial.begin(115200);
  Serial.print("Starting...\n");
  
}

void loop()
{ 
  
  while(millis()<5000)
  {
    scan();
    area = width * height;
    maxArea = area + 1400;   //1000
    minArea = area - 1000;
  }

    scan(); 

  if(m_signature == 1)
  {
    newarea = width * height;
    
      if (x < Xmin)
      {     
       left();
      }
      else if (x > Xmax)
      {
       right();
      }
      else if(newarea < minArea)
      {
       forward(); 
      }
      else if(newarea > maxArea)
      {
       backward();
       stop();
      }
      
      else
      {
        stop(); 
      } 
   }
   else
   {
    stop();
    //right_slow(); //rotate to search for blocks
     }
}

void backward()
  {
  right_servo.write(97);  //Back
  left_servo.write(86);
  delay(700);
  }

void forward()
  {
  right_servo.write(85);  //Forward
  left_servo.write(100);
  delay(100);
  }

void right()
  {
  right_servo.write(91);  //Right
  left_servo.write(180);
  delay(250);
  }

void right_slow()
  {
  right_servo.write(95);  //Right slow
  left_servo.write(95);
  delay(50);
  }

void left()
  {
  right_servo.write(-180);  //Left
  left_servo.write(92);
  delay(250);
  }

void stop()
  {
  right_servo.write(91);  //Stop
  left_servo.write(92);
  delay(200); 
  }
  
void scan()
  {
  uint16_t blocks;
  blocks = pixy.ccc.getBlocks();
  
  m_signature = pixy.ccc.blocks[i].m_signature;
  x = pixy.ccc.blocks[i].m_x;
  y = pixy.ccc.blocks[i].m_y;
  width = pixy.ccc.blocks[i].m_width;
  height = pixy.ccc.blocks[i].m_height;
  }
